import 'dart:convert';

class Lyric {
  String? lyric;
  Duration? startTime;
  Duration? endTime;
  bool isRemark;

  Lyric({this.lyric, this.startTime, this.endTime, this.isRemark = false});

  @override
  String toString() {
    return jsonEncode(toJson(this));
  }

  Lyric fromJson(Map json) {
    Lyric data = Lyric();
    if (json['lyric'] != null) {
      data.lyric = json['lyric'].toString();
    }
    if (json['startTime'] != null) {
      data.startTime = Duration(milliseconds: json['startTime']);
    }
    if (json['endTime'] != null) {
      data.endTime = Duration(milliseconds: json['endTime']);
    }
    if (json['isRemark'] != null) {
      data.isRemark = json['isRemark'];
    }
    return data;
  }

  Map<String, dynamic> toJson(Lyric entity) {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['lyric'] = entity.lyric;
    data['startTime'] = entity.startTime?.inMilliseconds ?? 0;
    data['endTime'] = entity.endTime?.inMilliseconds ?? 0;
    data['isRemark'] = entity.isRemark;
    return data;
  }
}
